% File: ux_exp_1.m
% From Appendix 2 - 'Order Conditions for Finite-Difference
%                   Approximations', of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
%
clear all
clc
%
% Varying order of differentiator
  for ndss=2:2:10
%
% Grid in x
  xl=0.0;
  xu=1.0;
  n=11;
  dx=(xu-xl)/(n-1);
%
% Test exponential
  a=1.0;
  for i=1:n
    x(i)=xl+(i-1)*dx;
    u(i)=exp(a*x(i));
  end
%
% ux
  if ndss==2   ux=dss002(xl,xu,n,u); end
  if ndss==4   ux=dss004(xl,xu,n,u); end
  if ndss==6   ux=dss006(xl,xu,n,u); end
  if ndss==8   ux=dss008(xl,xu,n,u); end
  if ndss==10  ux=dss010(xl,xu,n,u); end
%
% Comparison of numerical and analytical ux
  fprintf('\n\n ndss = %2d   a = %4.2f\n\n',ndss,a);
  for i=1:n
    uxa(i)=a*exp(x(i));
    err(i)=ux(i)-uxa(i);
    fprintf(' i = %3d  ux(i) = %8.5f  uxa(i) = %8.5f  err(i) = %8.5f\n',...
            i,ux(i),uxa(i),err(i));
  end
%
% Next differentiator
  end