% File: uxx_exp_d_1.m
% From Appendix 2 - 'Order Conditions for Finite-Difference
%                   Approximations', of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
%
clear all
clc
%
% Varying order of differentiator
  for ndss=42:2:50
%
% Grid in x
  xl=0.0;
  xu=1.0;
  n=12;
  dx=(xu-xl)/(n-1);
%
% Test exponential
  a=1.0;
  for i=1:n
    x(i)=xl+(i-1)*dx;
    u(i)=exp(a*x(i));
  end
%
% uxx, Dirichlet BC
  nl=1;
  nu=1;
  ux=zeros(1,n);
  if ndss==42  uxx=dss042(xl,xu,n,u,ux,nl,nu); end
  if ndss==44  uxx=dss044(xl,xu,n,u,ux,nl,nu); end
  if ndss==46  uxx=dss046(xl,xu,n,u,ux,nl,nu); end
  if ndss==48  uxx=dss048(xl,xu,n,u,ux,nl,nu); end
  if ndss==50  uxx=dss050(xl,xu,n,u,ux,nl,nu); end
%
% Comparison of numerical and analytical uxx
  fprintf('\n\n ndss = %2d   a = %4.2f\n\n',ndss,a);
  for i=1:n
    uxxa(i)=a^2*exp(a*x(i));
    err(i)=uxx(i)-uxxa(i);
    fprintf(' i = %3d  uxx(i) = %8.5f  uxxa(i) = %8.5f  err(i) = %8.5f\n',...
            i,uxx(i),uxxa(i),err(i));
  end 
%
% Next differentiator
  end