% File: pde_1.m
% From Appendix 4 - 'Implementation of Time-Varying Boundary Conditions',
%                   of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_1(t,u)
%
% Problem parameters
  global a D n xl xu dx ncall ndss
%
% PDE
  dx2=dx^2;
  for i=1:n
    if(i==1)  
      ubc=1-cos(a*pi*t);
      ut(1)=(u(2)-2.0*u(1)+ubc)/dx2;
    elseif(i==n) 
      ut(i)=2.0*(u(i-1)-u(i))/dx2;
    else  
      ut(i)=(u(i+1)-2.0*u(i)+u(i-1))/dx2;
    end    
  end
  ut=D*ut';
%
% Increment calls to pde_1
  ncall=ncall+1;

  
