% File: pde_2.m
% From Appendix 4 - 'Implementation of Time-Varying Boundary Conditions',
%                   of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_2(t,u)
%
% Problem parameters
  global a D n xl xu ncall ndss
%
% Calculate ux
  ue(2:n+1)=u;
  ue(1)=1-cos(a*pi*t);
  if    (ndss== 2) uex=dss002(xl,xu,n+1,ue); % second order  
  elseif(ndss== 4) uex=dss004(xl,xu,n+1,ue); % fourth order
  elseif(ndss== 6) uex=dss006(xl,xu,n+1,ue); % sixth order
  elseif(ndss== 8) uex=dss008(xl,xu,n+1,ue); % eighth order      
  elseif(ndss==10) uex=dss010(xl,xu,n+1,ue); % tenth order
  end     
%
% BC at x = 1 (Neumann)
  uex(n+1)=0.0;
%
% Calculate uxx
  if    (ndss== 2) uexx=dss002(xl,xu,n+1,uex); % second order  
  elseif(ndss== 4) uexx=dss004(xl,xu,n+1,uex); % fourth order
  elseif(ndss== 6) uexx=dss006(xl,xu,n+1,uex); % sixth order
  elseif(ndss== 8) uexx=dss008(xl,xu,n+1,uex); % eighth order      
  elseif(ndss==10) uexx=dss010(xl,xu,n+1,uex); % tenth order
  end     
%
% PDE
  uxx=uexx(2:n+1);
  ut=D*uxx';
%
% Increment calls to pde_2
  ncall=ncall+1;

