% File: pde_3.m
% From Appendix 4 - 'Implementation of Time-Varying Boundary Conditions',
%                   of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_3(t,u)
%
% Problem parameters
  global a D n xl xu ncall ndss
%
% Calculate ux
  ue(2:n+1)=u;
  ue(1)=1-cos(a*pi*t);
  uex(n+1)=0.0;
  nl=1; % Dirichlet
  nu=2; % Neumann
  if    (ndss==42) uexx=dss042(xl,xu,n+1,ue,uex,nl,nu); % second order  
  elseif(ndss==44) uexx=dss044(xl,xu,n+1,ue,uex,nl,nu); % fourth order
  elseif(ndss==46) uexx=dss046(xl,xu,n+1,ue,uex,nl,nu); % sixth order
  elseif(ndss==48) uexx=dss048(xl,xu,n+1,ue,uex,nl,nu); % eighth order      
  elseif(ndss==50) uexx=dss050(xl,xu,n+1,ue,uex,nl,nu); % tenth order
  end     
%
% PDE
  uxx=uexx(2:n+1);
  ut=D*uxx';
%
% Increment calls to pde_3
  ncall=ncall+1;

