% File: pde_7.m
% From Appendix 4 - 'Implementation of Time-Varying Boundary Conditions',
%                   of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_7(t,u)
%
% Problem parameters
  global a D n xl xu ncall ndss
%
% Calculate ux
  u(1)=1-cos(a*pi*t);
  ux(n)=0.0;
  nl=1; % Dirichlet
  nu=2; % Neumann
  if    (ndss==42) uxx=dss042(xl,xu,n,u,ux,nl,nu); % second order  
  elseif(ndss==44) uxx=dss044(xl,xu,n,u,ux,nl,nu); % fourth order
  elseif(ndss==46) uxx=dss046(xl,xu,n,u,ux,nl,nu); % sixth order
  elseif(ndss==48) uxx=dss048(xl,xu,n,u,ux,nl,nu); % eighth order      
  elseif(ndss==50) uxx=dss050(xl,xu,n,u,ux,nl,nu); % tenth order
  end     
%
% PDE
  ut=D*uxx';
%
% Increment calls to pde_7
  ncall=ncall+1;

