% File: quadJoin.m (rev. 1 - October 2012)
% From Appendix 6 - 'Animating Simulation Results', of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
%
function B=quadJoin(A) % (rev. 1 - October 2012)
%
%==========================================================
% Creates a four-quadrant image from a single quadrant image
% Called from movieSphericalDiffusion.m
%==========================================================
%
[m,n]=size(A);
% Pre-allocate array for four-quadrant
B=zeros(2*m-1,2*n-1); 
% Stitch together four quadrants obtained
% by flipping quarter-image vertically and
% horizontally
B(1:m       ,1:n)      =A(m:-1:1,n:-1:1);
B(1:m       ,n:(2*n-1))=A(m:-1:1,:);
B(m:(2*m-1),1:n)       =A(:,n:-1:1);
B(m:(2*m-1),n:(2*n-1)) =A(:,:);
