% File: pde_1.m
% From Chapter 1 - 'An Introduction to the Method of Lines', of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
%
%
% Extra file - not included in book!
%
function ut=pde_1(t,u)
%
global D xl xu
% Problem parameters
%   xl=0.0;
%   xu=1.0;
%
% PDE
  N=length(u);
  dx2=((xu-xl)/(N-1))^2;
  for i=1:N
    if(i==1 || i==N)
        u(i)=0.0;
        ut(i)=0.0; 
    elseif(i==N)
        u(i)=0.0;
        ut(i)=D*2.0*(u(i-1)-u(i))/dx2;
    else
        ut(i)=D*(u(i+1)-2.0*u(i)+u(i-1))/dx2;
    end    
  end      
  ut=ut';
