% File: pde_3.m
% From Chapter 3 - 'Green's Function Analysis', of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
%
  function ut=pde_3(t,u)
%
% Problem parameters
  global ncall ndss n xl xu
%
% Calculate uxx
  nl=1; % Dirichlet
  nu=1; % Dirichlet
  ux=zeros(1,n);
  if    (ndss==42) uxx=dss042(xl,xu,n,u,ux,nl,nu); % second order
  elseif(ndss==44) uxx=dss044(xl,xu,n,u,ux,nl,nu); % fourth order
  elseif(ndss==46) uxx=dss046(xl,xu,n,u,ux,nl,nu); % sixth order
  elseif(ndss==48) uxx=dss048(xl,xu,n,u,ux,nl,nu); % eighth order      
  elseif(ndss==50) uxx=dss050(xl,xu,n,u,ux,nl,nu); % tenth order
  end    
%
% PDE
  ut=uxx';
  ut(1)=0.0;
  ut(n)=0.0;
%
% Increment calls to pde_3
  ncall=ncall+1;
  

