% File: inital_1.m
% From Chapter 4 - 'Two Nonnlinear, Variable-Coefficient, Inhomogeneous
%                   Partial differential Equations', of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).  function y=inital_1(t0)
%
% Function init_1 is called by the main program to define the
% initial conditions in the MOL solution of two nonlinear PDEs
%
  global ncall   ncase...
             u       v...
             n       x      e4    ndss
%
% Spatial increment
  dx=1.0/(n-1);
%
% Values of x along the spatial grid
  x=[0.0:dx:1.0];
%
% Initial conditions
  for i=1:n
    u(i)=1.0;
    v(i)=1.0;
    y0(i)  =u(i);
    y0(i+n)=v(i);
  end
%
% Constant e^4 used in boundary condition
  e4=exp(1.0)^4;
%
% Initialize calls to pde_1
  ncall=0;
 
