% File: pde_2.m
% From Chapter 5 - 'Euler, Navier Stokes and Burgers Equations', 
%                   of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_2(t,u)
%
% Function pde_2 computes the t derivative vector for Burgers' equation
%
  global n x xl xu ncall ncase ndss vis
%  
% Calculate ux
  if      (ndss== 2) ux=dss002(xl,xu,n,u); % second order  
    elseif(ndss== 4) ux=dss004(xl,xu,n,u); % fourth order
    elseif(ndss== 6) ux=dss006(xl,xu,n,u); % sixth order
    elseif(ndss== 8) ux=dss008(xl,xu,n,u); % eighth order      
    elseif(ndss==10) ux=dss010(xl,xu,n,u); % tenth order
  end
%
% BC at x = 0
  ux(1)=0.0;
%
% BC at x = 1
  ux(n)=0.0;
%
% Calculate uxx
  if      (ndss== 2) uxx=dss002(xl,xu,n,ux); % second order  
    elseif(ndss== 4) uxx=dss004(xl,xu,n,ux); % fourth order
    elseif(ndss== 6) uxx=dss006(xl,xu,n,ux); % sixth order
    elseif(ndss== 8) uxx=dss008(xl,xu,n,ux); % eighth order      
    elseif(ndss==10) uxx=dss010(xl,xu,n,ux); % tenth order
  end
%
% PDE
  for i=1:n
    ut(i)=vis*uxx(i)-u(i)*ux(i);
  end
  ut=ut';
%
% Increment calls to pde_2
  ncall=ncall+1;

