% File: ua.m
% From Chapter 6 - 'The Cubic Schrodinger Equation' of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function uanal=ua(t,x)
%
% Function ua computes the analytical solution to the CSE
%
% The following exact solution is |u(x,t)|^2 which is compared
% with the numerical solution
%
  uanal=2.0*(2.0/(exp(x-t)+exp(-(x-t))))^2;
