% File: pde_1.m
% From Chapter 7 - 'The Korteweg-de Vries Equation' of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_1(t,u)
%
% Function pde_1 computes the t derivative vector for the KdV equation
%
  global xl xu n ncall    
%  
% Calculate ux
  ux=dss004(xl,xu,n,u); 
%
% Calculate uxxx
  uxxx=uxxx7c(xl,xu,n,u);
%
% PDE
  for i=1:n
    ut(i)=-uxxx(i)-6.0*u(i)*ux(i);
  end
  ut=ut';
%
% Increment calls to pde_1
  ncall=ncall+1;

