% File: pde_2.m
% From Chapter 7 - 'The Korteweg-de Vries Equation' of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_2(t,u)
%
% Function pde_2 computes the t derivative vector for the KdV equation
% using vectorized Matlab code for the PDE
%
  global xl xu n ncall    
%  
% Calculate ux
  ux=dss004(xl,xu,n,u); 
%
% Calculate uxxx
  uxxx=uxxx7c(xl,xu,n,u);
%
% PDE
  ut=-uxxx'-6.0*u.*ux';
%
% Increment calls to pde_1
  ncall=ncall+1;

