% File: ua.m
% From Chapter 7 - 'The Korteweg-de Vries Equation' of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function uanal=ua(x,t)
%
% Funtion uanal computes the exact solution of the KdV equation
% for comparison with the numerical solution. 
%
  global   c
%
% Analytical solution
  expm=exp(-1.0/2.0*sqrt(c)*(x-c*t));
  expp=exp( 1.0/2.0*sqrt(c)*(x-c*t)); 
  uanal=(1.0/2.0)*c*(2.0/(expp+expm))^2;

 