% File: pde_1.m
% From Chapter 8 - 'The Linear Wave Equation' of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_1(t,u)
%
% Function pde_1 computes the t derivative vector for the wave equation
%
  global  ncall     c    xl    xu     n
%  
% One vector to two vectors
  for i=1:n
    u1(i)=u(i);
    u2(i)=u(i+n);
  end
%
% Calculate u1xx with ux(1) = ux(n) = 0 BCs
  dxs=((xu-xl)/(n-1))^2;
  for i=1:n
     if(i==1)     u1xx(i)=2.0*(u1(i+1)-u1(i))/dxs;
     elseif(i==n) u1xx(i)=2.0*(u1(i-1)-u1(i))/dxs;
     else         u1xx(i)=(u1(i+1)-2.0*u1(i)+u1(i-1))/dxs;
     end       
  end   
%
% PDE
  cs=c^2;
  for i=1:n
    u1t(i)=u2(i);  
    u2t(i)=cs*u1xx(i);
  end
%
% Two vectors to one vector
  for i=1:n
    ut(i)  =u1t(i);
    ut(i+n)=u2t(i);
  end  
  ut=ut';
%
% Increment calls to pde_1
  ncall=ncall+1;

