% File: inital_1.m
% From Chapter 8 - 'The Linear Wave Equation' of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function u0=inital_1(t0)
%
% Function inital_1 sets the initial conditions for the wave equation
%
  global  ncall ncase  ndss   x    xl    xu     n
  global  c1 c2 lambda m x01 x02
%
% Spatial domain and initial condition
  x=linspace(xl,xu,n);
  u01=zeros(1,n); u02=u01; 
  u0=zeros(1,2*n);
  for i=1:n
    u01=-sqrt(1/lambda)*m*tanh(sqrt(2)*m*(-x(i)-x01+c1*t0)/(2*sqrt(1-c1^2)));
    u02=-sqrt(1/lambda)*m*tanh(sqrt(2)*m*(-x(i)-x02+c2*t0)/(2*sqrt(1-c2^2)));
    u0(i)=u02;%+u01;
    u0(i+n)=0.0;
  end
 
  
  
  
