% File: pde_2.m
% From Chapter 8 - 'The Linear Wave Equation' of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_2(t,u)
%
% Function pde_2 computes the t derivative vector for the wave equation
%
  global  ncall  ndss     c    xl    xu     n
%
% One vector to two vectors
  for i=1:n
    u1(i)=u(i);
    u2(i)=u(i+n);
  end
%
% Calculate u1x
  if    (ndss== 2) u1x=dss002(xl,xu,n,u1); % second order  
  elseif(ndss== 4) u1x=dss004(xl,xu,n,u1); % fourth order
  elseif(ndss== 6) u1x=dss006(xl,xu,n,u1); % sixth order
  elseif(ndss== 8) u1x=dss008(xl,xu,n,u1); % eighth order      
  elseif(ndss==10) u1x=dss010(xl,xu,n,u1); % tenth order
  end 
%
% BC at x = 0
  u1x(1)=0.0;
%
% BC at x = 1
  u1x(n)=0.0;
%
% Calculate u1xx
  if    (ndss== 2) u1xx=dss002(xl,xu,n,u1x); % second order  
  elseif(ndss== 4) u1xx=dss004(xl,xu,n,u1x); % fourth order
  elseif(ndss== 6) u1xx=dss006(xl,xu,n,u1x); % sixth order
  elseif(ndss== 8) u1xx=dss008(xl,xu,n,u1x); % eighth order      
  elseif(ndss==10) u1xx=dss010(xl,xu,n,u1x); % tenth order
  end
%
% PDE
  cs=c^2;
  for i=1:n
    u1t(i)=u2(i);  
    u2t(i)=cs*u1xx(i);
  end
%
% Two vectors to one vector
  for i=1:n
    ut(i)  =u1t(i);
    ut(i+n)=u2t(i);
  end  
  ut=ut';
%
% Increment calls to pde_2
  ncall=ncall+1;

