% File: plots_3D.m
% From Chapter 9 - 'Maxwell's equations' of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
%
% Run after pde_1_main.m to generate 3D Plots from Matlab workspace

  figure(1);
  surfl(x,t,u1); shading interp;
  title('E(x,t)');
  xlabel('x');
  ylabel('t');
  zlabel('E(x,t)');
  axis tight

% print -dpng -r300 fig3.png;

  figure(2);
  surfl(x,t,u2); shading interp;
  title('\partial/\partialt E(x,t)');
  xlabel('x');
  ylabel('t');
  zlabel('\partial/\partialt E(x,t)');
  axis tight
  rotate3d on

% print -dpng -r300 fig4.png;

