  function yt=pde_1(t,y)
%
% Problem parameters
  global ncall nx ny nz
  xl=0.0;
  xu=1.0;
  yl=0.0;
  yu=1.0;
  zl=0.0;
  zu=1.0;
  
  % Preallocate arrays
  uxx = zeros(nx,ny,nz);
  uyy = zeros(nx,ny,nz);
  uzz = zeros(nx,ny,nz);
  ut  = zeros(nx,ny,nz);
    
% 1D to 3D matrix conversion
  u=reshape(y,nx,ny,nz);
%
% PDE
  dx=(xu-xl)/(nx-1);
  dy=(yu-yl)/(ny-1);
  dz=(zu-zl)/(nz-1);  
  dx2=dx^2;
  dy2=dy^2;
  dz2=dz^2;
  for i=1:nx
  for j=1:ny  
  for k=1:nz 
%
%   uxx
    if(i~=1)&&(i~=nx), uxx(i,j,k)=(u(i+1,j,k)-2.0*u(i,j,k) ...
                                         +u(i-1,j,k))/dx2; end
%
%   uyy
    if(j==1),       uyy(i,j,k)=2.0*(u(i,j+1,k)-u(i,j,k))/dy2;
    elseif(j==ny),  uyy(i,j,k)=2.0*(u(i,j-1,k)-u(i,j,k))/dy2;
    else            uyy(i,j,k)=(u(i,j+1,k)-2.0*u(i,j,k)+u(i,j-1,k))/dy2;         
    end 
%
%   uzz
    if(k==1),      u0=u(i,j,k+1)-2.0*dz*(1.0-u(i,j,k));
                   uzz(i,j,k)=(u(i,j,k+1)-2.0*u(i,j,k)+u0)/dz2; 
    elseif(k==nz), u1=u(i,j,k-1)+2.0*dz*(1.0-u(i,j,k)); 
                   uzz(i,j,k)=(u1-2.0*u(i,j,k)+u(i,j,k-1))/dz2;
    else           uzz(i,j,k)=(u(i,j,k+1)-2.0*u(i,j,k)+u(i,j,k-1))/dz2;
    end
%
%   ut = uxx + uyy + uzz
    if(i==1)||(i==nx), ut(i,j,k)=0.0; 
    else ut(i,j,k)=uxx(i,j,k)+uyy(i,j,k)+uzz(i,j,k);
    end
  end      
  end
  end

% 3D to 1D matrix conversion
  yt=reshape(ut,nx*ny*nz,1);

%
% increment calls to pde_1
  ncall=ncall+1;

  
