  function yt=pde_2(t,y)
%
% Problem parameters
  global ncall nx ny nz ndss
  xl=0.0;
  xu=1.0;
  yl=0.0;
  yu=1.0;
  zl=0.0;
  zu=1.0;

% 1D to 3D matrix conversion
  u=reshape(y,nx,ny,nz);
% PDE
%
% Preallocate arrays
uxx=zeros(nx,ny,nz);
uyy=zeros(nx,ny,nz);
uzz=zeros(nx,ny,nz);
% ux
  for j=1:ny
  for k=1:nz    
    u1d=u(:,j,k);  
    if    (ndss== 2), ux1d=dss002(xl,xu,nx,u1d); % second order  
    elseif(ndss== 4), ux1d=dss004(xl,xu,nx,u1d); % fourth order
    elseif(ndss== 6), ux1d=dss006(xl,xu,nx,u1d); % sixth order
    elseif(ndss== 8), ux1d=dss008(xl,xu,nx,u1d); % eighth order      
    elseif(ndss==10), ux1d=dss010(xl,xu,nx,u1d); % tenth order
    end 
%   
% uxx
    if    (ndss== 2), uxx1d=dss002(xl,xu,nx,ux1d); % second order  
    elseif(ndss== 4), uxx1d=dss004(xl,xu,nx,ux1d); % fourth order
    elseif(ndss== 6), uxx1d=dss006(xl,xu,nx,ux1d); % sixth order
    elseif(ndss== 8), uxx1d=dss008(xl,xu,nx,ux1d); % eighth order      
    elseif(ndss==10), uxx1d=dss010(xl,xu,nx,ux1d); % tenth order
    end
%
% 1D to 3D    
    uxx(:,j,k)=uxx1d(:);
  end
  end
%
% uy
  for i=1:nx
  for k=1:nz    
    u1d=u(i,:,k);  
    if    (ndss== 2), uy1d=dss002(yl,yu,ny,u1d); % second order  
    elseif(ndss== 4), uy1d=dss004(yl,yu,ny,u1d); % fourth order
    elseif(ndss== 6), uy1d=dss006(yl,yu,ny,u1d); % sixth order
    elseif(ndss== 8), uy1d=dss008(yl,yu,ny,u1d); % eighth order      
    elseif(ndss==10), uy1d=dss010(yl,yu,ny,u1d); % tenth order
    end 
%   
% uyy
    uy1d(1) =0.0;
    uy1d(ny)=0.0;
    if    (ndss== 2), uyy1d=dss002(yl,yu,ny,uy1d); % second order  
    elseif(ndss== 4), uyy1d=dss004(yl,yu,ny,uy1d); % fourth order
    elseif(ndss== 6), uyy1d=dss006(yl,yu,ny,uy1d); % sixth order
    elseif(ndss== 8), uyy1d=dss008(yl,yu,ny,uy1d); % eighth order      
    elseif(ndss==10), uyy1d=dss010(yl,yu,ny,uy1d); % tenth order
    end
%
% 1D to 3D
    uyy(i,:,k)=uyy1d(:);
  end
  end
%
% uz
  for i=1:nx
  for j=1:ny    
    u1d=u(i,j,:);  
    if    (ndss== 2), uz1d=dss002(zl,zu,nz,u1d); % second order  
    elseif(ndss== 4), uz1d=dss004(zl,zu,nz,u1d); % fourth order
    elseif(ndss== 6), uz1d=dss006(zl,zu,nz,u1d); % sixth order
    elseif(ndss== 8), uz1d=dss008(zl,zu,nz,u1d); % eighth order      
    elseif(ndss==10), uz1d=dss010(zl,zu,nz,u1d); % tenth order
    end 
%   
% uzz
    uz1d(1) =1.0-u1d(1);
    uz1d(nz)=1.0-u1d(nz);
    if    (ndss== 2), uzz1d=dss002(zl,zu,nz,uz1d); % second order  
    elseif(ndss== 4), uzz1d=dss004(zl,zu,nz,uz1d); % fourth order
    elseif(ndss== 6), uzz1d=dss006(zl,zu,nz,uz1d); % sixth order
    elseif(ndss== 8), uzz1d=dss008(zl,zu,nz,uz1d); % eighth order      
    elseif(ndss==10), uzz1d=dss010(zl,zu,nz,uz1d); % tenth order
    end
%
% 1D to 3D
    uzz(i,j,:)=uzz1d(:);
  end
  end
%
% ut = uxx + uyy + uzz
  ut=uxx+uyy+uzz;
  ut(1,:,:) =0.0;
  ut(nx,:,:)=0.0;

% 3D to 1D matrix conversion
  yt=reshape(ut,nx*ny*nz,1);  
%
% increment calls to pde_2
  ncall=ncall+1;

