  function yt=pde_3(t,y)
%
% Problem parameters
  global ncall nx ny nz ndss
  xl=0.0;
  xu=1.0;
  yl=0.0;
  yu=1.0;
  zl=0.0;
  zu=1.0;
%
% Preallocate arrays
u=zeros(nx,ny,nz);
uxx=zeros(nx,ny,nz);
uyy=zeros(nx,ny,nz);
uzz=zeros(nx,ny,nz);
ux1d=zeros(1,nx);
uy1d=zeros(1,nx);
uz1d=zeros(1,nx);
yt=zeros(1,nx*ny*nz);
% 1D to 3D matrix conversion
  %u=reshape(y,nx,ny,nz);
  for i=1:nx
  for j=1:ny
  for k=1:nz
    u(i,j,k)=y((i-1)*ny*nz+(j-1)*nz+k);
  end
  end
  end
%
% PDE
%
% uxx
  for j=1:ny
  for k=1:nz    
    u1d=u(:,j,k);  
    nl=1; % Dirichlet
    nu=1; % Dirichlet
    %ux1d(:)=0.0; 
    ux1d(1) =0.0;
    ux1d(nx)=0.0;
    if    (ndss==42), uxx1d=dss042(xl,xu,nx,u1d,ux1d,nl,nu); % second order
    elseif(ndss==44), uxx1d=dss044(xl,xu,nx,u1d,ux1d,nl,nu); % fourth order
    elseif(ndss==46), uxx1d=dss046(xl,xu,nx,u1d,ux1d,nl,nu); % sixth order
    elseif(ndss==48), uxx1d=dss048(xl,xu,nx,u1d,ux1d,nl,nu); % eighth order      
    elseif(ndss==50), uxx1d=dss050(xl,xu,nx,u1d,ux1d,nl,nu); % tenth order
    end    
%
% 1D to 3D    
    uxx(:,j,k)=uxx1d(:);
  end
  end
%
% uyy
  for i=1:nx
  for k=1:nz    
    u1d=u(i,:,k);  
    nl=2; % Neumann
    nu=2; % Neumann
    uy1d(1) =0.0;
    uy1d(ny)=0.0;
    if    (ndss==42), uyy1d=dss042(yl,yu,ny,u1d,uy1d,nl,nu); % second order
    elseif(ndss==44), uyy1d=dss044(yl,yu,ny,u1d,uy1d,nl,nu); % fourth order
    elseif(ndss==46), uyy1d=dss046(yl,yu,ny,u1d,uy1d,nl,nu); % sixth order
    elseif(ndss==48), uyy1d=dss048(yl,yu,ny,u1d,uy1d,nl,nu); % eighth order      
    elseif(ndss==50), uyy1d=dss050(yl,yu,ny,u1d,uy1d,nl,nu); % tenth order
    end    
%
% 1D to 3D
    uyy(i,:,k)=uyy1d(:);
  end
  end
%
% uzz
  for i=1:nx
  for j=1:ny    
    u1d=u(i,j,:); 
    nl=2; % Neumann
    nu=2; % Neumann
    uz1d(1) =1.0-u1d(1);
    uz1d(nz)=1.0-u1d(nz);    
    if    (ndss==42), uzz1d=dss042(zl,zu,nz,u1d,uz1d,nl,nu); % second order
    elseif(ndss==44), uzz1d=dss044(zl,zu,nz,u1d,uz1d,nl,nu); % fourth order
    elseif(ndss==46), uzz1d=dss046(zl,zu,nz,u1d,uz1d,nl,nu); % sixth order
    elseif(ndss==48), uzz1d=dss048(zl,zu,nz,u1d,uz1d,nl,nu); % eighth order      
    elseif(ndss==50), uzz1d=dss050(zl,zu,nz,u1d,uz1d,nl,nu); % tenth order
    end    
%
% 1D to 3D
    uzz(i,j,:)=uzz1d(:);
  end
  end
%
% ut = uxx + uyy + uzz
  ut=uxx+uyy+uzz;
  ut(1,:,:) =0.0;
  ut(nx,:,:)=0.0;

% 3D to 1D matrix conversion
  % yt=reshape(ut,nx*ny*nz,1);
  for i=1:nx
  for j=1:ny
  for k=1:nz
    yt((i-1)*ny*nz+(j-1)*nz+k)=ut(i,j,k);
  end
  end
  end
  yt=yt';
  
% increment calls to pde_3
  ncall=ncall+1;
