% File: inital_1.m
% From Chapter 12 - 'Partial Differential Equation with a Mixed Partial
%                    Derivative', of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function u0=inital_1(t0)
%
% Function inital_1 sets the initial condition for the PDE with
% a mixed partial derivative
%
  global  a     x    xl    xu    dx    cm     n
%
% Grid spacing, constant a
  dx=(xu-xl)/(n+1);
  a=1.0/(1.0-(pi/(xu-xl))^2);
%
% IC over the spatial grid
  for i=1:n
%
%   Uniform grid
    x(i)=xl+i*dx;
%
%   Initial condition
    u0(i)=sin(pi*x(i)/(xu-xl));
  end
