% File: ua.m
% From Chapter 12 - 'Partial Differential Equation with a Mixed Partial
%                    Derivative', of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function uanal=ua(t,x)
%
% Function ua computes the analytical solution to the PDE with
% a mixed partial derivative
%
  global  a    xl    xu
%
% Analytical solution
  uanal=sin(pi*x/(xu-xl))*exp(a*t);
