% File: pde_1.m
% From Chapter 14 - 'Diffusion Equation in Spherical Coordinates',
%                    of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function ut=pde_1(t,u)
%
% Global area
  global r r0 nr D f tau ncall
%
% Spatial grid in r
  for i=1:nr
%
%   ur
    ur=dss004(0.0,r0,nr,u);
    ur(nr)=0.0;
    ur( 1)=0.0;        
%
%   urr
    urr=dss004(0.0,r0,nr,ur);
  end
%
% PDE
  for i=1:nr
    if(t<=tau)
      fs=f(i);  
    else    
      fs=0.0;
    end   
    if(i==1)  
      ut(i)=D*3.0*urr(i)+fs; 
    else
      ut(i)=D*(urr(i)+2.0/r(i)*ur(i))+fs;
    end  
  end
  ut=ut';
%
% Increment number of calls to pde_1
  ncall=ncall+1;
