% File: simp.m
% From Chapter 14 - 'Diffusion Equation in Spherical Coordinates',
%                    of the book:
% William E Schiesser and Graham W Griffiths (2009).
% A Compendium of Partial Differential Equation Models
% - Method of Lines Analysis with Matlab,
% Cambridge University Press (ISBN-13: 9780521519861).
  function uint=simp(xl,xu,n,u)
%
% Function simp computes an integral numerically by Simpson's 
% rule
%
    h=(xu-xl)/(n-1); 
    uint(1)=u(1)-u(n); 
      for i=3:2:n
        uint(1)=uint(1)+4.0*u(i-1)+2.0*u(i);  
      end
    uint=h/3.0*uint;

